# include <Servo.h>

// Define the pin numbers for the sensors and actuators
const int LED_PIN = 7;
const int WASH_BUTTON_PIN = D6;
const int DRY_BUTTON_PIN = D5;
const int FULL_BUTTON_PIN = D4;
const int WATER_SENSOR_PIN = 2;
const int LID_SENSOR_PIN = 3;
const int DRUM_PIN = D0;
const int WATER_PUMP_PIN = 5;
const int DRUM_SLOW = 24;
const int DRUM_FAST = 40;
const int DRUM_STOP = 0;
int potVal;
Servo esc;


void setup() {

    pinMode(LED_PIN, OUTPUT);
    pinMode(WASH_BUTTON_PIN, INPUT_PULLUP);
    pinMode(DRY_BUTTON_PIN, INPUT);
    pinMode(FULL_BUTTON_PIN, INPUT);
    pinMode(WATER_SENSOR_PIN, INPUT);
    pinMode(LID_SENSOR_PIN, INPUT);
    pinMode(DRUM_PIN, OUTPUT);
    Serial.begin(9600);
    esc.attach(DRUM_PIN, 1000, 2000); // the second and third parameters are the minimum and maximum pulse widths    
    esc.write(DRUM_STOP); //arm ESP
    delay(1000);
}

void loop() {
    // Wait for the wash button press
    if (digitalRead(WASH_BUTTON_PIN) == LOW) {
        // Check the water level and lid status
        if (digitalRead(WATER_SENSOR_PIN) == LOW && digitalRead(LID_SENSOR_PIN) == LOW) {
            // Start the wash cycle
            esc.write(DRUM_SLOW);
            Serial.println("wash");
            digitalWrite(WATER_PUMP_PIN, HIGH);
            delay(600);
            esc.write(DRUM_STOP);
            digitalWrite(WATER_PUMP_PIN, LOW);
              delay(400);
              digitalWrite(WATER_PUMP_PIN, HIGH);
           delay(400);
            digitalWrite(WATER_PUMP_PIN, LOW);
        } else {
            Serial.println("Not enough water or lid is open.");
                        digitalWrite(LED_PIN, HIGH);

        }
    }

    // Wait for the dry button press
//    if (digitalRead(DRY_BUTTON_PIN) == HIGH) {
 //       // Start the slow spin
   //             if (digitalRead(LID_SENSOR_PIN) == LOW) {

//esc.write(DRUM_FAST);
  //      delay(600);

        // Start the fast spin
    //    esc.write(DRUM_STOP);
     //   delay(300);
      //  esc.write(DRUM_FAST);
       // delay(300);/
//        esc.write(DRUM_STOP);
 //               }     else {
  //          Serial.println("lid is open.");
  //                      digitalWrite(LED_PIN, HIGH);

    //    }
   // }

    // Wait for the full cycle button press
   // if (digitalRead(FULL_BUTTON_PIN) == HIGH) {
        // Perform the wash cycle
    //    if (digitalRead(WATER_SENSOR_PIN) == LOW && digitalRead(LID_SENSOR_PIN) == LOW) {
            // Start the wash cycle
//             esc.write(DRUM_SLOW);

  //          digitalWrite(WATER_PUMP_PIN, HIGH);
    //        delay(600);
      //       esc.write(DRUM_STOP);
   //         digitalWrite(WATER_PUMP_PIN, LOW);
     //           delay(400);
      //      digitalWrite(WATER_PUMP_PIN, HIGH);
       //    delay(400);
    //        digitalWrite(WATER_PUMP_PIN, LOW);
     //   } else {
      //      Serial.println("Not enough water or lid is open.");
       //      digitalWrite(LED_PIN, HIGH);
        //    return;
//        }

        // Perform the dry cycle
        // Start the slow spin
  //      if (digitalRead(LID_SENSOR_PIN) == LOW) {
   //      esc.write(DRUM_SLOW);

    //    delay(200);

        // Start the fast spin
     //   esc.write(DRUM_FAST);

      //  delay(200);
       //  esc.write(DRUM_STOP);
       // delay(200);
      //   esc.write(DRUM_FAST);

       // delay(100);
      //   esc.write(DRUM_STOP);

    
      // } else {
       //     Serial.println("Not enough water or lid is open.");
        //     digitalWrite(LED_PIN, HIGH);
     //       return;
    //    }

    }}

